from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from StringIO import StringIO
from PloneTrashcan import PloneTrashcan_globals

def install_subskin(self, out, skin_name, globals):
    skinstool=getToolByName(self, 'portal_skins')
    if skin_name not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', globals)

    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName) 
        path = [i.strip() for i in  path.split(',')]
        try:
            if skin_name not in path:
                path.insert(path.index('custom') +1, skin_name)
        except ValueError:
            if skin_name not in path:
                path.append(skin_name)  

        path = ','.join(path)
        skinstool.addSkinSelection(skinName, path)

        
def install(self):
    out = StringIO()
    
    # Install new skins

    install_subskin(self, out, 'plone_trashcan', PloneTrashcan_globals)
                                               
    at=getToolByName(self, 'portal_membership')    

    # Add Trashcan to portal_membership
    
    if 'mytrashcan' not in [action.id for action in at.listActions()]:
        at.addAction( 'mytrashcan'
                    , 'My Trashcan'
                    , 'string:${portal/portal_membership/getHomeUrl}/.trashcan/folder_contents'
                    , 'python: member and hasattr(portal.portal_membership.getHomeFolder(), ".trashcan")'
                    , 'View'
                    , 'user' )
        print >> out, "Added My Trashcan."
            
    print >> out, "Successfully installed Trashcan."
    return out.getvalue()
